/* cmutekinet.h */
/*
************************************************************************
Copyright notice:

(1) Distribute, copy or modify as you like, freely or for profit.
(2) Do not restrict anyone else from doing the same.
(3) Retain this copyright on all copies
(4) No warranties expressed or implied.

Dr. Bithead software

May this be used to the Glory of God
************************************************************************
*/

#ifndef __CMUTEK_INET
#define __CMUTEK_INET

#include "novms.h"

#define DENYIPACCESS 0
#define GRANTIPACCESS 1
int defaultipaccess=DENYIPACCESS;	/* external default access */
					/* - can be changed by calling program*/

/* ip long from numeric ip characters */
#define IPTOUL( IPCHARPTR, IPLONG)\
  {\
  u_char *bits8by4 = (u_char *) (&IPLONG);\
  int tmpbits[4];\
  int tmpint;\
    DPR( (">%s< = IP characters\n", IPCHARPTR) );\
\
    if ( 4 == sscanf( IPCHARPTR, "%d.%d.%d.%d", &tmpbits[SWBI(3)], \
    &tmpbits[SWBI(2)], &tmpbits[SWBI(1)], &tmpbits[SWBI(0)]))\
      for ( tmpint=0; tmpint<4; tmpint++)\
        bits8by4[tmpint] = (u_char) tmpbits[tmpint];\
    else\
      IPLONG= 0;\
    DPR( (">%08x< = IP int result\n", IPLONG) );\
  }

#if !VMS

/* no access checking for now for Eunuchs(tm) */
#define checkipaccess(A,B) GRANTIPACCESS

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* IP address from sockaddr */
#define GETSOCKIP( SCKADR) ((struct sockaddr_in *)(SCKADR))->sin_addr.s_addr

/* byte order in IP address */
#ifdef sun
#define SWBI(I) (3-I)
#endif

#ifdef mips
#define SWBI(I) (3-I)
#endif

#ifdef whoknows
#define SWBI(I) (I)	/* nobody's needed this yet */
#endif

#ifndef SWBI
#define SWBI(I) (3-I)	/* so assume any new machines need it this way */
#endif

/* SOCKADDR macro load up internet socket address structure
   parameters:  SCKADR:  pointer to sockaddr structure
                ADDR:    host string pointer - ip adress (e.g. 128.84.242.21) or
                           NULL
                PORT:    internet port number

SCKADR:  pointer to sockaddr or sockaddr_in structure

   (1) interpret addr string 
       (a) as NULL = port only 
         OR
       (b) as ip address nnn.mmm.lll.kkk
   (2) load result into sockaddr structure 

   ***N.B. there is no error checking - effects and results undefined for
           improper addresses
*/
#define LOADSOCKADDR( SCKADR, ADDR, PORT)\
  {\
    struct sockaddr_in *SCKADRIN;\
    char *lcladdr;\
\
    SCKADRIN = (struct sockaddr_in *)(SCKADR);\
    lcladdr=(char *) (ADDR);\
    SCKADRIN->sin_family = (short) AF_INET;\
    SCKADRIN->sin_port = (u_short) PORT;\
\
    if ( ! lcladdr) {\
      SCKADRIN->sin_addr.s_addr= 0;\
    }\
    else {\
      IPTOUL( lcladdr, GETSOCKIP( SCKADRIN))\
      }\
  }      

#else /* !VMS */

#include types
#include socket
#include string

#ifndef IPPROTO_TCP
#define IPPROTO_TCP 0  /* for VMS/CMUTEK - this doesn't matter */
#endif

struct in_addr {
        u_long  bits32;
};

struct sockaddr_cmutek {
        short   sin_family;
        u_short sin_port;
        struct  in_addr sin_addr;	/* standard 32 bit address */
        char    *inhostnm;		/* if sin_addr is all 1's, then */
        char    inet_dummy[4];		/* inhostnm points to host name */
};

struct sockunion {
  union {
    struct sockaddr generic;
    struct sockaddr_cmutek cmutek;
  };
};

/* IP address from sockaddr */
#define GETSOCKIP( SCKADR) ((struct sockaddr_cmutek *)(SCKADR))->sin_addr.bits32

/* byte order in IP address */
#define SWBI(I) (3-I)

/* SOCKADDR macro load up cmutek internet socket  address structure
   parameters:  SCKADR:  pointer to sockaddr or sockaddr_cmutek structure
                ADDR:    host string pointer - ip adress (e.g. 128.84.242.21) or
                           alpha address (e.g. cukoo1.tn.cornell.edu) or NULL
                PORT:    internet port number

SCKADR:  pointer to sockaddr or sockaddr_cmutek structure

   (1) interpret addr string 
       (a) as NULL = port only 
         OR
       (b) as ip address nnn.mmm.lll.kkk if 1st char numeric 
         OR
       (c) as ascii address
   (2) load result into sockaddr_cmutek structure 

   ***N.B. there is no error checking - effects and results undefined for
           improper addresses
*/
#define LOADSOCKADDR( SCKADR, ADDR, PORT)\
  {\
    struct sockaddr_cmutek *SCKADRCMU;\
    char *lcladdr;\
\
    SCKADRCMU = (struct sockaddr_cmutek *)(SCKADR);\
    lcladdr=ADDR;\
    SCKADRCMU->sin_family = (short) AF_INET;\
    SCKADRCMU->sin_port = PORT;\
\
    if ( ! lcladdr) {\
      SCKADRCMU->inhostnm=NULL;\
      SCKADRCMU->sin_addr.bits32= 0;\
    }\
    else\
      if ( !( ( '0' <= *lcladdr) && ( *lcladdr <= '9'))) {\
        SCKADRCMU->inhostnm=lcladdr;\
        SCKADRCMU->sin_addr.bits32= 0xffffffff;\
      }\
      else {\
        SCKADRCMU->inhostnm=NULL;\
        IPTOUL( lcladdr, GETSOCKIP( SCKADRCMU))\
      }\
  }      

#endif /* !VMS */
#endif /* __CMUTEK_INET */
/* end cmutekinet.h */
