/* cmutekmacro.h */
/*
************************************************************************
Copyright notice:

(1) Distribute, copy or modify as you like, freely or for profit.
(2) Do not restrict anyone else from doing the same.
(3) Retain this copyright on all copies
(4) No warranties expressed or implied.

Dr. Bithead software

May this be used to the Glory of God
************************************************************************
*/

#ifndef EVMSERR
#include errno
#endif

/* look for failure */
#define CHECK( status) ( !$VMS_STATUS_SUCCESS( status))

/* signal IOSB device-specific status for SS$_ABORT in IOSB VMS status */
#define CHECKSB( IOSB) \
        if ( IOSB.NSB$STATUS ==  SS$_ABORT)\
          lib$signal( IOSB.NSB$UNION2.NSB$XSTATUS);\
        else if CHECK( IOSB.NSB$STATUS) lib$signal( IOSB.NSB$STATUS);

/* special macro to ignore case of closing connection - presumably
   because we are closing also */
#define CHECKSBCLOSE( IOSB) \
  if ( ( IOSB.NSB$STATUS != SS$_ABORT) ||\
       ( IOSB.NSB$UNION2.NSB$XSTATUS != NET$_CC)\
     ) CHECKSB( IOSB);

/* exit on failure of status */
#define CHECKEX( status) if CHECK( status)\
  { vaxc$errno=status;\
    errno=EVMSERR;\
    return( -1);\
  }

/* exit on non-success of IOSB status */
#define CHECKSBEX( IOSB) {\
        CHECKSB( IOSB);\
        CHECKEX( IOSB.NSB$STATUS);\
        }

/* end cmutekmacro.h */
