/* inet_cmutil.c - socket(), accept(), &c for cmutek iptcp */
/*
************************************************************************
Copyright notice:

(1) Distribute, copy or modify as you like, freely or for profit.
(2) Do not restrict anyone else from doing the same.
(3) Retain this copyright on all copies
(4) No warranties expressed or implied.

Dr. Bithead software

May this be used to the Glory of God
************************************************************************
*/
char *malloc();

#include stddef
#include lnmdef
#include ssdef
#include stsdef
#include descrip
#include "tcpdefs.hcmu"
#include "debug.h"
#include "cmutekerr.h"
#include "cmutekinet.h"

#define FHOSTNMSIZ ( sizeof IP_Information.Foreign_Host)
#define LHOSTNMSIZ ( sizeof IP_Information.Local_Host)

int sys$trnlnm(), sys$assign(), sys$qio(), sys$qiow(), sys$hiber();
int sys$exit(), sys$wake(), sys$waitfr(), sys$clref();
int lib$get_ef(), lib$free_ef();

/* foward-linked list macros */

/* find item matching field */
/*  search forward-linked list,
     - set (ITEM *) MATCHPTR
     - for MATCHPTR->SUBFIELD == MATCHFIELD
     - starting search of ITEM's from first ITEM at pointer BASE->next
    or
     - set MATCHPTR = NULL for no match */
    
#define FIND_ITEM( BASE, ITEM, SUBFIELD, MATCHFIELD, MATCHPTR)\
\
  {\
  int tmp1=0;\
    MATCHPTR=BASE;\
    if ( BASE) {\
      do {\
        MATCHPTR=MATCHPTR->next;\
        tmp1 = ( MATCHPTR) ? ( MATCHPTR->SUBFIELD == MATCHFIELD) : 1;\
      } while ( !tmp1);\
    }\
  }

/*  - add memory for ITEM 
    - to forward-linked list of ITEM's
    - at first position after BASE i.e. at BASE->next */

#define ADD_ITEM( BASE, ITEM)\
\
  {\
    ITEM *tmp1;\
    if ( !BASE) {\
      BASE = (ITEM *) malloc( sizeof( ITEM));\
      BASE->next = NULL;\
    }\
    tmp1 = (ITEM *) malloc( sizeof( ITEM));\
    tmp1->next=BASE->next;\
    BASE->next=tmp1;\
  }

/*  delete memory and (ITEM *)
    - at (ITEM *) DELITEM
    - from forward-linked list of ITEM's
    - starting search for DELITEM from BASE->next */

#define DEL_ITEM( BASE, ITEM, DELITEM) \
\
  if ( base) {\
    ITEM *tmp1;\
    FIND_ITEM( BASE, ITEM, next, DELITEM, tmp1)\
    if ( tmp1) {\
      tmp1->next=DELITEM->next;\
      free( DELITEM);\
    }\
  }

/* base of linked list for channel info */

struct chistr {
   int chan;              /* key for searching through forward-linked list */
   IP_Information ip;     /* from TCP$INFO */
   NetSB_Fields iosb;     /* private iosb */
   u_long ef;             /* private event flag */
   struct chistr *next;   /* pointer to next item in forward-linked list */
   };

typedef struct chistr chinfo;

static chinfo *basechaninfo;    /* assumes static will init pointer to NULL */

/**********************************************************************/
/* host specific IP: device name ***N.B. ip_log must be in lnm$system_table */
/* returns malloc'ed (struct dsc$descriptor_s *) */
/* also malloc's space for data at (struct dsc$descriptor_s *)->dsc$a_pointer */
/* returns NULL if it can't malloc descriptor or data area */
/**********************************************************************/

struct dsc$descriptor_s *IP_Device( ip_log, default_ip_device)
char *ip_log;			/* optional system logical name to translate */
char *default_ip_device;	/* device to use if logical name not there */
{
long status;
char ans[LNM$C_NAMLENGTH+1];	/* equiv. name w/room for ASCIZ terminator*/
u_short anslen;			/* returned length of ans */

struct dsc$descriptor_s logdsc	/* descriptor pointing to logical name */
   = { strlen(ip_log),
       DSC$K_DTYPE_T,
       DSC$K_CLASS_S,
       ip_log};

/* descriptor pointing to logical name table in which ip_log can be found */
$DESCRIPTOR( tabdsc, "LNM$SYSTEM_TABLE"); /* lnm$system for security */

unsigned long attr = LNM$M_CASE_BLIND;	/* attribute and itemlist for $trnlnm */
struct { u_short buflen;
         short itemcode;
         char *bufadr;
         u_short *lenaddr;
         long endlist;			/* set to zero..........v*/
       } itmlst = { LNM$C_NAMLENGTH, LNM$_STRING, ans, &anslen, 0};

static struct dsc$descriptor_s *retdsc;
/**********************************************************************/
/* start IP_Device execution */

  status=sys$trnlnm( &attr, &tabdsc, &logdsc, 0, &itmlst);

  if CHECK( status) {
    strcpy( ans, default_ip_device);
    anslen = strlen( ans);
    DPR(("using IP_device default >%s<\n", ans));
  }
  else {
    ans[anslen]='\0';
    DPR(("using IP_device result >%s<\n", ans));
  }

  retdsc= (struct dsc$descriptor_s *)malloc( sizeof( struct dsc$descriptor_s));
  if ( retdsc) {
    retdsc->dsc$a_pointer = malloc( anslen);
    if ( !( retdsc->dsc$a_pointer)) { free( retdsc); return( NULL);}
    retdsc->dsc$w_length = anslen;
    retdsc->dsc$b_dtype = DSC$K_DTYPE_T;
    retdsc->dsc$b_class = DSC$K_CLASS_S;
    strncpy( retdsc->dsc$a_pointer, ans, anslen);
  }
  return( retdsc);     /* returns NULL address on failure */

} /* end IP_Device */

/**********************************************************************/
/* read */
/**********************************************************************/
int inet_recv( s, buf, len, flags)
int s;
char *buf;
int len, flags; 
{
chinfo *chaninfo;
int status;
int *i4=(int *) buf;

  FIND_ITEM( basechaninfo, chinfo, chan, s, chaninfo);

  if ( chaninfo) {
    sys$clref( chaninfo->ef);
    status=sys$qiow( chaninfo->ef, chaninfo->chan, TCP$RECEIVE, 
                     &chaninfo->iosb, 0, 0,
                     buf, len, 0, 0, 0, 0);
    CHECKEX( status)
    DPR( ("Received >%08x</%d> in %d bytes\n", *i4, *i4, 
                                   chaninfo->iosb.NSB$BYTE_COUNT));
    CHECKSBEX( chaninfo->iosb)
    if ( $VMS_STATUS_SUCCESS( chaninfo->iosb.NSB$STATUS))
      return( (int) chaninfo->iosb.NSB$BYTE_COUNT);
  }
  return( -1);
}

/**********************************************************************/
/* send */
/**********************************************************************/
int inet_send( s, buf, len, flags)
int s;
char *buf;
int len, flags; 
{
chinfo *chaninfo;
int status;
int *i4=(int *) buf;

  FIND_ITEM( basechaninfo, chinfo, chan, s, chaninfo);

  if ( chaninfo) {
    sys$clref( chaninfo->ef);
    status=sys$qiow( chaninfo->ef, chaninfo->chan, TCP$SEND, 
                     &chaninfo->iosb, 0, 0,
                     buf, len, 0, 0, 0, 0);
    CHECKEX( status)

/* iosb does not get the # of bytes transferred so just assume ss$_normal
   means everything went out */

    DPR( ("Sent >%08x</%d> in %d bytes\n", *i4, *i4, len));
    CHECKSBEX( chaninfo->iosb)
    if ( $VMS_STATUS_SUCCESS( chaninfo->iosb.NSB$STATUS)) return( len);
  }
  return( -1);
}

/**********************************************************************/
/* accept - waits for event flag of bind */
/* XXX N.B. does not return new socket fd */
/**********************************************************************/
int inet_accept( s, addr, addrlen)
int s;
struct sockaddr *addr;
int *addrlen;
{
struct sockaddr_cmutek *addrptr;
chinfo *chaninfo;
int status;

  FIND_ITEM( basechaninfo, chinfo, chan, s, chaninfo);

  if ( chaninfo) {

    sys$waitfr( chaninfo->ef);
    DPR(("%08xx=bind $qio iosb status\n", chaninfo->iosb.NSB$STATUS));
    DPR(("%08xx=bind $qio iosb flags & ICMP-code\n", 
                    chaninfo->iosb.NSB$UNION2.NSB$XSTATUS ));
    CHECKSBEX( chaninfo->iosb)

    status=sys$qiow( chaninfo->ef, chaninfo->chan, TCP$INFO, &chaninfo->iosb, 
                     0, 0,
                     &chaninfo->ip, sizeof( IP_Information), 0, 0, 0, 0);

    DPR( ( "%08xx=accept $INFO status\n", status));
    CHECKEX( status)
    DPR( ( "%08xx=accept $INFO IOSB status\n", chaninfo->iosb.NSB$STATUS));
    CHECKSBEX( chaninfo->iosb)

    DPR( ( "%5d=accept $INFO IOSB byte count\n", 
                        chaninfo->iosb.NSB$BYTE_COUNT));
    DPR( ( "%08xx=accept $INFO IOSB flags & ICMP-code\n", 
                    chaninfo->iosb.NSB$UNION2.NSB$XSTATUS ));

#if DEBUG
    { char tmp[255];
      strncpy( tmp, chaninfo->ip.CI$Foreign_Host, 
                    chaninfo->ip.CI$FHost_Name_Size);
      tmp[ chaninfo->ip.CI$FHost_Name_Size] ='\0';
      printf( "%s\n%08x=FHost %d=FPort\n", tmp,
               chaninfo->ip.CI$Remote_Internet_Adrs, 
               chaninfo->ip.CI$Foreign_Port);

      strncpy( tmp, chaninfo->ip.CI$Local_Host, 
                    chaninfo->ip.CI$LHost_Name_Size);

      tmp[ chaninfo->ip.CI$LHost_Name_Size] ='\0';
      printf( "%s\n%08x=LHost %d=LPort\n", tmp,
               chaninfo->ip.CI$Local_Internet_Adrs, chaninfo->ip.CI$Local_Port);
    }
#endif
    addrptr = (struct sockaddr_cmutek *) addr;
    addrptr->inhostnm=chaninfo->ip.CI$Foreign_Host;
    addrptr->sin_addr.bits32=chaninfo->ip.CI$Remote_Internet_Adrs;
    return( s);
  }
  return(-1);
}
/**********************************************************************/
/* close */
/**********************************************************************/
int inet_close(s)
int s;
{
int status;
int closeflags=0; /* normal, wait */
chinfo *chaninfo;

  FIND_ITEM( basechaninfo, chinfo, chan, s, chaninfo);

  if ( chaninfo) {
    sys$clref( chaninfo->ef);
    status=sys$qiow( chaninfo->ef, ( u_short) s, TCP$CLOSE, &chaninfo->iosb, 
                     0, 0,
                     closeflags, 0, 0, 0, 0, 0);

    DPR( ( "%04xx=$CLOSE status\n", status));
    CHECKEX( status)
    DPR( ( "%04xx=$CLOSE IOSB status\n", chaninfo->iosb.NSB$STATUS));
    CHECKSBCLOSE( chaninfo->iosb)

    return( 0);
  }
  return( -1);
}
/**********************************************************************/
/* socket - simply assign a channel */
/**********************************************************************/
int inet_socket( domain, type, protocol)
int domain, type, protocol;
{
int status;
u_short ctlchan;
chinfo *chaninfo;
struct dsc$descriptor_s *ip_device$dsc;
/*
  if ( argc > 1) myport=atoi( argv[1]);
  else myport=WILD;
*/

  ip_device$dsc = IP_Device( IP_Pointer, DEFAULT_IP_Device);

  status=sys$assign( ip_device$dsc, &ctlchan, 0, 0);

  if ( ip_device$dsc) {
    free( ip_device$dsc->dsc$a_pointer);
    free( ip_device$dsc);
  }

  CHECKEX( status)

  ADD_ITEM( basechaninfo, chinfo)
  chaninfo=basechaninfo->next;
  chaninfo->chan=(int) ctlchan;

  status=lib$get_ef( &chaninfo->ef);
  DPR(("%08xx=lib$get_ef - %d=event flag\n", status, chaninfo->ef));

  return( chaninfo->chan);
}

/**********************************************************************/
/* bind - asynchronously open a passive port */
/**********************************************************************/
int inet_bind( s, name, namelen)
int s;
struct sockaddr *name;
int namelen;
{

int status;
struct sockaddr_cmutek *addrptr;
u_long myport;
chinfo *chaninfo;

  FIND_ITEM( basechaninfo, chinfo, chan, s, chaninfo);

  if ( chaninfo) {

    addrptr = (struct sockaddr_cmutek *) name;
    myport = (u_long) addrptr->sin_port;

    sys$clref( chaninfo->ef);
    status=sys$qio( chaninfo->ef, (u_short) s, TCP$OPEN, &chaninfo->iosb, 
                    0, 0,
                    0, 0, myport, Passive | ( Synch << 1), U$TCP_Protocol, 0);
    DPR(("%08xx=bind $qio status\n", status));
    CHECKEX( status)
/* asynch $qio - iosb status checked in accept */

    return( 0);
  }
return(-1);
}

/**********************************************************************/
/* connect - synchronously open an active port */
/**********************************************************************/
int inet_connect( s, name, namelen)
int s;
struct sockaddr *name; /* if 32-bit address = FFFFFFFFx then use ASCIZ */
int namelen;
{

int status;
struct sockaddr_cmutek *addrptr;
u_long hisport;
char *lcladdr;
typedef struct lclhoststruc { u_long lcllen; char lcladdr[129];} lclhostype;
lclhostype *lclhostname;
int lclhnsiz = sizeof( lclhostype);
chinfo *chaninfo;

  FIND_ITEM( basechaninfo, chinfo, chan, s, chaninfo);

  if ( chaninfo) {

    addrptr = (struct sockaddr_cmutek *) name;
    hisport = (u_long) addrptr->sin_port;
    lclhostname=NULL;

    if ( addrptr->sin_addr.bits32 == -1)
      lcladdr = addrptr->inhostnm;

    else {     /* get host name from ip address */

      lclhostname = (lclhostype *) malloc( lclhnsiz);
      sys$clref( chaninfo->ef);
      status=sys$qiow( chaninfo->ef, (u_short) s, GTHST, &chaninfo->iosb, 0, 0,
                       lclhostname, lclhnsiz, GTH_ADRNAM, 
                       addrptr->sin_addr.bits32, 
                       0, 0);
      CHECKEX( status)
      CHECKSBEX( chaninfo->iosb)

/* ASCIZ-ize (i.e. null terminate) lcladdr */

      lclhostname->lcladdr[ lclhostname->lcllen]='\0';

      lcladdr = lclhostname->lcladdr;
    }

    sys$clref( chaninfo->ef);
    status=sys$qiow( chaninfo->ef, (u_short) s, TCP$OPEN, &chaninfo->iosb, 0, 0,
                     lcladdr, hisport,
                     0, Active | ( Synch << 1), U$TCP_Protocol, 0);

    DPR(("%08xx=connect $qiow\n", status));
    CHECKEX( status)
    DPR(("%08xx=connect $qiow IOSB status\n", chaninfo->iosb.NSB$STATUS));
    CHECKSBEX( chaninfo->iosb)

/* cleanup */

    if ( lclhostname) { free( lclhostname); lclhostname=NULL;}

    return( 0);
  }
  return( -1);
}

/**********************************************************************/
/* checkipaccess - checks ip address against hosts_deny and hosts_equiv */
/*   in input lnm table (lnmtbl) */
/* returns GRANTIPACCESS to allow access, DENYIPACCESS to deny access */
/* expects equivalence name strings fo form a.b.c.d_e.f.g.h */
/*   where first address is to be OR'ed and second is to be AND'ed with */
/*   input ip address (ipaddr) and match is declared if ipaddr */
/*   does not change */
/* deny-access check is performed first - first match returns DENYIPACCESS */
/* grant-access check is performed second - first match returns GRANTIPACCESS */
/* fall through both checks returns DENYIPACCESS */
/* if anything fails, returns DENYIPACCESS */
/* equivalence name of 0.0.0.0_0.0.0.0 terminates search for that logical */
/* this is a pretty simple-minded check that should be fairly easy to */
/*   get around by someone with login access to your machine, so don't pin */
/*   any great hopes on this routine - esp w/the external defaultipaccess */
/**********************************************************************/

int checkipaccess( lnmtbl, ipaddr)
char *lnmtbl;		/* null terminated string */
u_long ipaddr;
{
u_long oraddr, andaddr;		/* address masks for determining access */
int status;			/* $trnlnm status and on-error return status */
extern int defaultipaccess;	/* on-error & fall-through return status */
				/*   for this routine */

/* descriptor pointing to logical name table in which */
/* hosts_deny & hosts_equiv can be found */
struct dsc$descriptor_s tabdsc
   = { strlen( lnmtbl),
       DSC$K_DTYPE_T,
       DSC$K_CLASS_S,
       lnmtbl};

/* descriptors for logical names */
$DESCRIPTOR( denydsc, "HOSTS_DENY");
$DESCRIPTOR( equivdsc, "HOSTS_EQUIV");

char ans[LNM$C_NAMLENGTH+1];	/* equiv. name w/room for ASCIZ terminator*/
u_short anslen;			/* returned length of ans */
char *ansus;

/* itmlst to get the equivalence name */

long lnmidx, lnmidxlen;
unsigned long attr = LNM$M_CASE_BLIND;	/* attribute and itemlist for $trnlnm */
struct { u_short buflen1; short itemcode1; char *bufadr1; u_short *lenaddr1;
         u_short buflen2; short itemcode2; char *bufadr2; u_short *lenaddr2;
         long endlist;			/* set to zero..........v*/
       } strlst = { sizeof lnmidx, LNM$_INDEX, &lnmidx, &lnmidxlen,
                    LNM$C_NAMLENGTH, LNM$_STRING, ans, &anslen,
                    0};
/* itmlst to get the max index of equivalence names */
long maxidx, maxidxlen;
struct { u_short buflen1; short itemcode1; char *bufadr1; u_short *lenaddr1;
         long endlist;			/* set to zero..........v*/
       } maxidxlst = { sizeof maxidx, LNM$_MAX_INDEX, &maxidx, &maxidxlen,
                       0};

/**********************************************************************/
/* start checkipaccess execution */

  DPR(( "defaultipaccess=%s\n", 
    ( defaultipaccess==DENYIPACCESS) ? "deny" : "grant" ));

  if CHECK( status=sys$trnlnm( &attr, &tabdsc, &denydsc, 0, &maxidxlst)) 
    return( defaultipaccess);

/* loop through checks for access denial */
  lnmidx=0;
  while ( lnmidx <= maxidx) {

/* translate lnm */
    if CHECK( status=sys$trnlnm( &attr, &tabdsc, &denydsc, 0, &strlst)) 
      return( defaultipaccess);

    ans[anslen]='\0';
    DPR(("checking hosts_deny[%d]=>%s<\n", lnmidx, ans));

/* get | and & addresses */
    IPTOUL( ans, oraddr)
    if ( ansus = strchr( ans,'_')) IPTOUL( ansus+1, andaddr)
    else andaddr=0;

/* check for end of list - oraddr = andaddr = 0 */
/*   - if it is the end, access will not be denied unless ipaddr is 0, */
/*     so set lnmidx to finish loop */
    if ( ! ( oraddr || andaddr)) lnmidx=maxidx;

/* do the check */
    if ( (ipaddr == ( ipaddr | oraddr)) && (ipaddr == ( ipaddr & andaddr)) )
      return( DENYIPACCESS);

    lnmidx++;
  }

  if CHECK( status=sys$trnlnm( &attr, &tabdsc, &equivdsc, 0, &maxidxlst)) 
    return( defaultipaccess);

/* loop through checks for access grant */
/* - don't bother checking if default is to grant access */
  lnmidx=0;
  while ( ( lnmidx <= maxidx) && ( defaultipaccess != GRANTIPACCESS) ){

/* translate lnm */
    if CHECK(   status=sys$trnlnm( &attr, &tabdsc, &equivdsc, 0, &strlst)) 
      return( defaultipaccess);

    ans[anslen]='\0';
    DPR(("checking hosts_equiv[%d]=>%s<\n", lnmidx, ans));

/* get | and & addresses */
    IPTOUL( ans, oraddr)
    if ( ansus = strchr( ans,'_')) IPTOUL( ansus+1, andaddr)
    else andaddr=0;

/* check for end of list - oraddr = andaddr = 0 */
/*   - if it is the end, access will not be granted here unless ipaddr is 0, */
/*     so set lnmidx to finish loop */
    if ( ! ( oraddr || andaddr)) lnmidx=maxidx;

/* do the grant-access check */
/*  this return should be the only path for access because it has not been */
/*  denied earlier and the loop will finish */
    if ( (ipaddr == ( ipaddr | oraddr)) && (ipaddr == ( ipaddr & andaddr)) )
      return( GRANTIPACCESS);

    lnmidx++;
  }

/* drop through - not denied, not granted - use default */
  DPR(( "defaultipaccess used\n"));
  return( defaultipaccess);

} /* end checkipaccess */
