/* socktest.c - test inet_cmutil pseudo-sockets */
/*
************************************************************************
Copyright notice:

(1) Distribute, copy or modify as you like, freely or for profit.
(2) Do not restrict anyone else from doing the same.
(3) Retain this copyright on all copies
(4) No warranties expressed or implied.

Dr. Bithead software

May this be used to the Glory of God
************************************************************************
*/

#include stdio

#define accept dummyaccept
#include "cmutekinet.h"

/* Debug PRint */
#ifndef DPR

#ifndef DEBUG
#define DEBUG FALSE
#endif

#if DEBUG
#define DPR(A) printf A

#else
#define DPR(A) /* */
#endif /* DEBUG */

#endif /* ndef DPR */

#undef accept

int accept();/* int sd, struct sockaddr *S_addr, int *addrlen);*/

int inet_accept(), inet_connect(), inet_socket(), inet_bind();
int inet_send(), inet_recv(), inet_close();

#include errno

#define CHK( i) if ( i==-1) printf("-1>>%d, errno=%d\n", i, errno)
main( argc, argv)
int argc;
char *argv[];
{
char sngl, masterrecv[80], slaverecv[80];
int fdslave, fdmaster, fdaccept, masterint, slaveint;
struct sockaddr slaveaddr, masteraddr;
struct sockaddr_cmutek *slaveaddrcmu, *masteraddrcmu;
int slaveaddrlen, masteraddrlen;
int slave=999;
int master=0;
int nnn;
char gotch;

  slaveaddrcmu=( struct sockaddr_cmutek *) &slaveaddr;
  masteraddrcmu=( struct sockaddr_cmutek *) &masteraddr;
  printf("S(lave or ()master:  ");

  gotch =  tolower( getchar());

  while( getchar() != '\n' ) ;

  if ( gotch != 's') {

/* client = master */

    printf("\n");
    fdmaster = inet_socket( AF_UNIX, SOCK_STREAM, NULL);
    printf( "fdmaster=inet_socket() = %d\n", fdmaster);
    LOADSOCKADDR( &masteraddr, argv[1], slave)

    masteraddrlen=sizeof( struct sockaddr);

    slaveaddrlen=sizeof( struct sockaddr);
    masterint  = inet_connect( fdmaster, &masteraddr, masteraddrlen);
    printf( "inet_connect(master) = %d\n", masterint);
    CHK( masterint);

    printf( "press return to inet_send 111:\n");
    while ( getchar() != '\n') ;
    masterint = inet_send( fdmaster, "111", 3, NULL);
    printf( "inet_send( fdmaster, 111, 3, NULL) = %d\n", masterint);
    CHK( masterint);

    masterint = inet_recv( fdmaster, masterrecv, sizeof(masterrecv), NULL);
    masterrecv[masterint]='\0';
    printf( "inet_recv( fdmaster, %s, %d, NULL) = %d\n", masterrecv, 
                     sizeof(masterint), masterint);
    CHK( masterint);

    masterint = inet_close( fdmaster);
    printf( "inet_close( fdmaster) = %d\n", masterint);
    CHK( masterint);
  }

/* server = slave */

  else {
    printf("\n");
    fdslave = inet_socket( AF_UNIX, SOCK_STREAM, NULL);
    printf( "fdslave=inet_socket() = %d\n", fdslave);

    LOADSOCKADDR( &slaveaddr, NULL, slave)
    slaveaddrlen=sizeof( struct sockaddr);
    slaveint = inet_bind( fdslave, &slaveaddr, slaveaddrlen);
    printf( "inet_bind(slave) = %d\n", slaveint);
    CHK( slaveint);

    masteraddrlen=sizeof( struct sockaddr);
    fdaccept=inet_accept( fdslave, &masteraddr, &masteraddrlen);
    printf( "inet_accept( %d, &masteraddr, &masteraddrlen) = %d\n",
     fdslave, fdaccept);
    CHK( fdaccept);
    printf( "%08xx=masteraddrcmu->sin_addr.bits32\n", 
                        masteraddrcmu->sin_addr.bits32);
    printf( "%20s=masteraddrcmu->inhostnm\n", masteraddrcmu->inhostnm);

    slaveint = inet_close( fdslave);
    printf( "inet_close( fdslave) = %d\n", slaveint);
    CHK( slaveint);

    slaveint = inet_recv( fdaccept, slaverecv, sizeof(slaverecv), NULL);
    slaverecv[slaveint]='\0';
    printf( "inet_recv( fdaccept, %3s, %d, NULL) = %d\n", slaverecv, 
              sizeof(slaverecv), slaveint);
    CHK( slaveint);

    printf( "press return to inet_send 222:");
    while ( getchar() != '\n') ;
    slaveint = inet_send( fdaccept, "222", 3, NULL);
    printf( "\n\ninet_send( fdaccept, 222, 3, NULL) = %d\n", slaveint);
    CHK( slaveint);

    slaveint = inet_close( fdaccept);
    printf( "inet_close( fdaccept) = %d\n", slaveint);
    CHK( slaveint);
  }
}
